/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.geometries.gui;

import org.visnow.vn.geometries.parameters.RegularField3DParams;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class RegularField3DMapPanel extends javax.swing.JPanel
{

    protected RegularField3DParams params = new RegularField3DParams();

    /**
     * Creates new form RegularField3DMapPanel
     */
    public RegularField3DMapPanel()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        dataPanel = new javax.swing.JPanel();
        gridTypeCombo = new javax.swing.JComboBox();
        showExternFacesPanel = new javax.swing.JPanel();
        iMinSurfBox = new javax.swing.JCheckBox();
        iMaxSurfBox = new javax.swing.JCheckBox();
        jMinSurfBox = new javax.swing.JCheckBox();
        jMaxSurfBox = new javax.swing.JCheckBox();
        kMaxSurfBox = new javax.swing.JCheckBox();
        kMinSurfBox = new javax.swing.JCheckBox();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        faceMapCombo = new javax.swing.JComboBox();
        boxDisplayCombo = new javax.swing.JComboBox();
        colorEditor = new org.visnow.vn.gui.widgets.ColorEditor();
        gridDensityBox = new javax.swing.JComboBox();
        lineWidthSlider = new javax.swing.JSlider();
        outlineBox = new javax.swing.JCheckBox();
        volumeShadingGUI = new org.visnow.vn.geometries.gui.VolumeShadingGUI();
        jPanel1 = new javax.swing.JPanel();

        setBorder(javax.swing.BorderFactory.createEtchedBorder());
        setRequestFocusEnabled(false);
        setLayout(new java.awt.GridBagLayout());

        dataPanel.setLayout(new java.awt.GridBagLayout());

        gridTypeCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "no grid", "point grid", "line grid", "volume rendering" }));
        gridTypeCombo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gridTypeComboActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        dataPanel.add(gridTypeCombo, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(3, 1, 3, 1);
        add(dataPanel, gridBagConstraints);

        showExternFacesPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        showExternFacesPanel.setLayout(new java.awt.GridBagLayout());

        iMinSurfBox.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        iMinSurfBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                iMinSurfBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        showExternFacesPanel.add(iMinSurfBox, gridBagConstraints);

        iMaxSurfBox.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        iMaxSurfBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                iMaxSurfBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        showExternFacesPanel.add(iMaxSurfBox, gridBagConstraints);

        jMinSurfBox.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jMinSurfBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMinSurfBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        showExternFacesPanel.add(jMinSurfBox, gridBagConstraints);

        jMaxSurfBox.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jMaxSurfBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMaxSurfBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        showExternFacesPanel.add(jMaxSurfBox, gridBagConstraints);

        kMaxSurfBox.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        kMaxSurfBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kMaxSurfBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        showExternFacesPanel.add(kMaxSurfBox, gridBagConstraints);

        kMinSurfBox.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        kMinSurfBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kMinSurfBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        showExternFacesPanel.add(kMinSurfBox, gridBagConstraints);

        jLabel6.setText("max");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        showExternFacesPanel.add(jLabel6, gridBagConstraints);

        jLabel7.setText("min");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        showExternFacesPanel.add(jLabel7, gridBagConstraints);

        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel8.setText("i");
        jLabel8.setMaximumSize(new java.awt.Dimension(20, 15));
        jLabel8.setMinimumSize(new java.awt.Dimension(20, 15));
        jLabel8.setPreferredSize(new java.awt.Dimension(20, 15));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        showExternFacesPanel.add(jLabel8, gridBagConstraints);

        jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel9.setText("j");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        showExternFacesPanel.add(jLabel9, gridBagConstraints);

        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel10.setText("k");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        showExternFacesPanel.add(jLabel10, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(showExternFacesPanel, gridBagConstraints);

        faceMapCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "slice", "average projection", "maximum projection" }));
        faceMapCombo.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "color faces by", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        faceMapCombo.setMinimumSize(new java.awt.Dimension(122, 40));
        faceMapCombo.setOpaque(false);
        faceMapCombo.setPreferredSize(new java.awt.Dimension(122, 40));
        faceMapCombo.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                faceMapComboItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(faceMapCombo, gridBagConstraints);

        boxDisplayCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "no extern faces", "inside of box", "box", "selected faces" }));
        boxDisplayCombo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boxDisplayComboActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 0, 0);
        add(boxDisplayCombo, gridBagConstraints);

        colorEditor.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                colorEditorStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        add(colorEditor, gridBagConstraints);

        gridDensityBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "coarse", "fine", "very fine" }));
        gridDensityBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gridDensityBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(gridDensityBox, gridBagConstraints);

        lineWidthSlider.setMajorTickSpacing(20);
        lineWidthSlider.setMinorTickSpacing(5);
        lineWidthSlider.setPaintTicks(true);
        lineWidthSlider.setValue(10);
        lineWidthSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("line/point width"));
        lineWidthSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                lineWidthSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(lineWidthSlider, gridBagConstraints);

        outlineBox.setSelected(true);
        outlineBox.setText("show outline");
        outlineBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                outlineBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(outlineBox, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(volumeShadingGUI, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void iMinSurfBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_iMinSurfBoxActionPerformed
    {//GEN-HEADEREND:event_iMinSurfBoxActionPerformed
        params.setSurfaces(0, 0, iMinSurfBox.isSelected());
        updateSliceSelection();
    }//GEN-LAST:event_iMinSurfBoxActionPerformed

    private void iMaxSurfBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_iMaxSurfBoxActionPerformed
    {//GEN-HEADEREND:event_iMaxSurfBoxActionPerformed
        params.setSurfaces(0, 1, iMaxSurfBox.isSelected());
        updateSliceSelection();
    }//GEN-LAST:event_iMaxSurfBoxActionPerformed

    private void jMinSurfBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jMinSurfBoxActionPerformed
    {//GEN-HEADEREND:event_jMinSurfBoxActionPerformed
        params.setSurfaces(1, 0, jMinSurfBox.isSelected());
        updateSliceSelection();
    }//GEN-LAST:event_jMinSurfBoxActionPerformed

    private void jMaxSurfBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jMaxSurfBoxActionPerformed
    {//GEN-HEADEREND:event_jMaxSurfBoxActionPerformed
        params.setSurfaces(1, 1, jMaxSurfBox.isSelected());
        updateSliceSelection();
    }//GEN-LAST:event_jMaxSurfBoxActionPerformed

    private void kMinSurfBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_kMinSurfBoxActionPerformed
    {//GEN-HEADEREND:event_kMinSurfBoxActionPerformed
        params.setSurfaces(2, 0, kMinSurfBox.isSelected());
        updateSliceSelection();
    }//GEN-LAST:event_kMinSurfBoxActionPerformed

    private void kMaxSurfBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_kMaxSurfBoxActionPerformed
    {//GEN-HEADEREND:event_kMaxSurfBoxActionPerformed
        params.setSurfaces(2, 1, kMaxSurfBox.isSelected());
        updateSliceSelection();
    }//GEN-LAST:event_kMaxSurfBoxActionPerformed

    private void gridTypeComboActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_gridTypeComboActionPerformed
    {//GEN-HEADEREND:event_gridTypeComboActionPerformed
        int k = gridTypeCombo.getSelectedIndex();
        params.setGridType(k);
        gridDensityBox.setVisible(k == RegularField3DParams.GRID_TYPE_POINTS || 
                                  k == RegularField3DParams.GRID_TYPE_LINES);
        volumeShadingGUI.setVisible(k == RegularField3DParams.RENDER_VOLUME &&
                                    params.isVolumeRenderingPossible());
    }//GEN-LAST:event_gridTypeComboActionPerformed

    private void faceMapComboItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_faceMapComboItemStateChanged
    {//GEN-HEADEREND:event_faceMapComboItemStateChanged
        if (params != null)
            params.setDataMap(faceMapCombo.getSelectedIndex());
    }//GEN-LAST:event_faceMapComboItemStateChanged

    private void boxDisplayComboActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_boxDisplayComboActionPerformed
    {//GEN-HEADEREND:event_boxDisplayComboActionPerformed
        if (params != null)
            params.setFacesDisplay(boxDisplayCombo.getSelectedIndex());
        setFaceButtonsEnabled(boxDisplayCombo.getSelectedIndex() == RegularField3DParams.SELECTED_FACES);
    }//GEN-LAST:event_boxDisplayComboActionPerformed

    private void colorEditorStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_colorEditorStateChanged
    {//GEN-HEADEREND:event_colorEditorStateChanged
        params.setBoxColor(colorEditor.getColor());
    }//GEN-LAST:event_colorEditorStateChanged

    private void gridDensityBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_gridDensityBoxActionPerformed
    {//GEN-HEADEREND:event_gridDensityBoxActionPerformed
        int[] gridDens = new int[]{20, 50, 100};
        int i = Math.min(2,gridDensityBox.getSelectedIndex());
        params.setGridLines(gridDens[i]);
    }//GEN-LAST:event_gridDensityBoxActionPerformed

    private void lineWidthSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_lineWidthSliderStateChanged
    {//GEN-HEADEREND:event_lineWidthSliderStateChanged
        params.setGridWidth(lineWidthSlider.getValue());
    }//GEN-LAST:event_lineWidthSliderStateChanged

    private void outlineBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_outlineBoxActionPerformed
    {//GEN-HEADEREND:event_outlineBoxActionPerformed
        params.setOutline(outlineBox.isSelected());
    }//GEN-LAST:event_outlineBoxActionPerformed

    public void setParams(RegularField3DParams params)
    {
        this.params = params;
        volumeShadingGUI.setParams(params.getVolumeShadingParams());
        params.setGui(this);
    }

    public void setVolumeRenderingPossible(boolean volumeRenderingPossible)
    {
        if (volumeRenderingPossible)
            gridTypeCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "no grid", "point grid", "line grid", "volume rendering"}));
        else
            gridTypeCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "no grid", "point grid", "line grid"}));
    }
    /**
     * Enables slice selection panel if any of extern faces is selected; Disables panel otherwise.
     */
    private void updateSliceSelection()
    {
        faceMapCombo.setEnabled(kMaxSurfBox.isSelected() || kMinSurfBox.isSelected() ||
            iMaxSurfBox.isSelected() || iMinSurfBox.isSelected() ||
            jMaxSurfBox.isSelected() || jMinSurfBox.isSelected());
    }

    @Override
    public void setEnabled(boolean enabled)
    {
        dataPanel.setEnabled(enabled);
        showExternFacesPanel.setEnabled(enabled);

        gridTypeCombo.setEnabled(enabled);

        iMaxSurfBox.setEnabled(enabled);
        iMinSurfBox.setEnabled(enabled);
        jMaxSurfBox.setEnabled(enabled);
        jMinSurfBox.setEnabled(enabled);
        kMaxSurfBox.setEnabled(enabled);
        kMinSurfBox.setEnabled(enabled);
    }

    private void setFaceButtonsEnabled(boolean enabled)
    {
        iMaxSurfBox.setEnabled(enabled);
        iMinSurfBox.setEnabled(enabled);
        jMaxSurfBox.setEnabled(enabled);
        jMinSurfBox.setEnabled(enabled);
        kMaxSurfBox.setEnabled(enabled);
        kMinSurfBox.setEnabled(enabled);
    }
    
    public void updateDataValuesFromParams()
    {
        
    }

    public VolumeShadingGUI getVolumeShadingGUI() {
        return volumeShadingGUI;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JComboBox boxDisplayCombo;
    protected org.visnow.vn.gui.widgets.ColorEditor colorEditor;
    protected javax.swing.JPanel dataPanel;
    protected javax.swing.JComboBox faceMapCombo;
    protected javax.swing.JComboBox gridDensityBox;
    protected javax.swing.JComboBox gridTypeCombo;
    protected javax.swing.JCheckBox iMaxSurfBox;
    protected javax.swing.JCheckBox iMinSurfBox;
    protected javax.swing.JLabel jLabel10;
    protected javax.swing.JLabel jLabel6;
    protected javax.swing.JLabel jLabel7;
    protected javax.swing.JLabel jLabel8;
    protected javax.swing.JLabel jLabel9;
    protected javax.swing.JCheckBox jMaxSurfBox;
    protected javax.swing.JCheckBox jMinSurfBox;
    protected javax.swing.JPanel jPanel1;
    protected javax.swing.JCheckBox kMaxSurfBox;
    protected javax.swing.JCheckBox kMinSurfBox;
    protected javax.swing.JSlider lineWidthSlider;
    protected javax.swing.JCheckBox outlineBox;
    protected javax.swing.JPanel showExternFacesPanel;
    protected org.visnow.vn.geometries.gui.VolumeShadingGUI volumeShadingGUI;
    // End of variables declaration//GEN-END:variables

}
